import es, gamethread, services, cfglib

info = es.AddonInfo()
info.name     = "Bullet Time TF2"
info.version  = "0.1"
info.url      = "None"
info.basename = "sic_bt"
info.author   = "sicman_adrian"
es.ServerVar(info.basename, info.version, 'Bullet Time').makepublic()

player_dict = {}

timescale = es.ServerVar('host_timescale')

config = cfglib.AddonCFG(es.getAddonPath("bullettime") + "/bullettime.cfg")
config.text("**************************")
config.text("       Bullet Time        ")
config.text("**************************")
sic_bullettime   = config.cvar("sic_bullettime",   1, "Enables/Disables bullet time together")
sic_bullettime_sound_enter   = config.cvar("sic_bullettime_sound_enter",   'mb_bullettime/enter1.mp3', "The Sound when bullet time begins")
sic_bullettime_sound_end   = config.cvar("sic_bullettime_sound_end",   'mb_bullettime/exit1.mp3', "The Sound when bullet time ends")
sic_bullettime_announce   = config.cvar("sic_bullettime_announce",   1, "This announces How many streaks a player has when he spawns")
config.text("\n")
config.text("**************************")
config.text("   Kill Streak Settings   ")
config.text("**************************")
sic_killingstreaks   = config.cvar("sic_killingstreaks",   1, "Enables/Disable Every so amount of kills bullet time will be activated")
sic_killingstreaks_kills   = config.cvar("sic_killingstreaks_kills",   5, "Amount of kills in a row needed")
sic_killingstreaks_slowdown   = config.cvar("sic_killingstreaks_slowdown",   0.2, "Speed it slows down to. Recommand to keep default")
sic_killingstreaks_time   = config.cvar("sic_killingstreaks_time",   5, "Amount of time bullet time last")
sic_killingstreaks_announce   = config.cvar("sic_killingstreaks_announce",   1, "Announces What player and amount of kills")
config.text("\n")
config.text("**************************")
config.text("      1vs 1 Settings      ")
config.text("**************************")
sic_1v1  = config.cvar("sic_1v1",   1, "Enables/Disbale When a player wins a 1v1 triigers a bullet time")
sic_1v1_slowdown   = config.cvar("sic_1v1_slowdown",   0.2, "Speed it slows down to. Recommand to keep default")
sic_1v1_time   = config.cvar("sic_1v1_time",   5, "Amount of time bullet time last")
config.text("\n")
config.text("**************************")
config.text("       Flag Settings      ")
config.text("**************************")
sic_flag_captured  = config.cvar("sic_flag_captured",   1, "Enables\disables When flag captured")
sic_flag_captured_slowdown   = config.cvar("sic_flag_captured_slowdown",   0.2, "Speed it slows down to. Recommand to keep default")
sic_flag_captured_time   = config.cvar("sic_flag_captured_time",   5, "Time the bullet time last")

sic_flag_events  = config.cvar("sic_flag_events",   1, "Enables\disables pick up, capture, defend, dropped triggering Buellet Time")
config.text("\n")
config.text("**************************")
config.text("      Round Settings      ")
config.text("**************************")
sic_round_start  = config.cvar("sic_round_start",   1, "Enables\disables When round starts triggers Bullet Time")
sic_round_start_slowdown   = config.cvar("sic_round_start_slowdown",   0.2, "Speed it slows down to. Recommand to keep default")
sic_round_start_time   = config.cvar("sic_round_start_time",   5, "Time the bullet time last")

sic_win  = config.cvar("sic_win",   1, "Enables\disables When a team wins")
sic_win_slowdown   = config.cvar("sic_win_slowdown",   0.2, "Speed it slows down to. Recommand to keep default")
sic_win_time   = config.cvar("sic_win_time",   5, "Time the bullet time last")
config.text("\n")
config.text("**************************")
config.text("      Round Settings      ")
config.text("**************************")


config.write()


class player:
    def __init__(self, userid):
        self.killed = 0
        self.userid = userid
    def giveKill(self):
        self.killed += 1
        if self.killed == player_dict[self.userid]['streak']:
            time = sic_killingstreaks_time
            speed = sic_killingstreaks_slowdown
            player_dict[self.userid]['streak'] += int(sic_killingstreaks_kills)
            if sic_killingstreaks_announce:
                es.msg('#multi', '#green[Bullet Time]#default Player #lightgreen%s #default is on a killing streak.  He\'s killed #green%s#default in a row' % (es.getplayername(self.userid), self.killed))
            bullettrigger(time,speed)
    def resetKill(self):
        self.killed = 0

killers = {}

def load():
    config.execute()
    es.flags('remove', 'notify', 'sv_cheats')

'''
    if not es.exists("command", str(sic_bullettime_trigger)):
        es.regsaycmd(str(sic_bullettime_trigger), "bullettime/trigger")
'''


'''
    if es.exists("command", str(sic_bullettime_trigger)):
        es.unregsaycmd(str(sic_bullettime_trigger))
'''

def bullettrigger(time,speed):
    if sic_bullettime:
        if timescale == 1:
            userid = es.getuserid()
            enter_sound(userid)
            es.server.queuecmd('sv_cheats 1')
            es.server.queuecmd('host_timescale %s' % speed)
            gamethread.delayed(time, end, (userid))


def enter_sound(userid):
    es.emitsound('player', userid, str(sic_bullettime_sound_enter), 1.0, 0)

def end(userid):
    es.emitsound('player', userid, str(sic_bullettime_sound_end), 1.0, 0)
    gamethread.delayed(1, es.server.queuecmd, 'host_timescale 1')
    es.server.queuecmd('sv_cheats 0')

def player_activate(ev):
    global killers
    killers[ev['userid']] = player(ev['userid'])
    if ev['userid'] not in player_dict:
        player_dict[ev['userid']] = {'streak':int(sic_killingstreaks_kills)}

def player_death(ev):
    userid = ev['userid']
    weapon = ev['weapon']
    attacker = ev['attacker']
    if int(attacker):
        killers[attacker].giveKill()
        killers[userid].resetKill()
    if sic_1v1:
        if es.getlivingplayercount() == 1:
            if timescale == 1:
                time = sic_1v1_time
                speed = sic_1v1_slowdown
                es.msg('#multi', '#green[Bullet Time]#default Player #lightgreen%s #defaultkilled #lightgreen%s #defaultIn a 1v1 triggering Bullet Time' % (es.getplayername(userid), es.getplayername(attacker)))
                bullettrigger(time, speed)

def ctf_flag_captured(ev):
    if sic_flag_captured:
        if timescale == 1:
            time = sic_flag_captured_time
            speed = sic_flag_captured_slowdown
            bullettrigger(time, speed)

def teamplay_round_start(ev):
    if sic_round_start:
        if timescale == 1:
            time = sic_round_start_time
            speed = sic_round_start_slowdown
            bullettrigger(time, speed)

def teamplay_round_win(ev):
    if sic_win:
        if timescale == 1:
            time = sic_win_time
            speed = sic_win_slowdown
            bullettrigger(time, speed)

def teamplay_flag_event(ev):
    if sic_events:
        if timescale == 1:
            time = sic_flag_captured_time
            speed = sic_flag_captured_slowdown
            bullettrigger(time, speed)
'''
def trigger():
    if not auth.isUseridAuthorized(es.getcmduserid(), 'bullettime'):
        if es.getargc() >= 2:
            time = es.getuserid(es.getargv(1))
            speed = int(es.getargv(2))
            bullettrigger(time, speed)
        else:
            es.tell(es.getcmduserid(), '#multi', '#greenInvalide Syntax #lightgreen@god <name/userid/name> <1-on/0-off>')
    else:
        es.tell(es.getcmduserid(), '#multi','#greenYou are not authorized to run this command')
'''

def player_disconnect(ev):
    del killers[ev['userid']]
    del player_dict[ev['userid']]